//Please insert as a fragment on the RDC Page on the bottom of the screen.

<script 
    src="//ajax.aspnetcdn.com/ajax/4.0/1/MicrosoftAjax.js" 
    type="text/javascript">
</script>
<script type="text/javascript"  src="/sites/IRBApplications/_layouts/15/sp.runtime.js">
</script>
<script type="text/javascript"  src="/sites/IRBApplications/_layouts/15/sp.js">
</script> 



<script type="text/javascript"  src="/sites/IRBApplications/SiteAssets/js/jquery.js"></script>





<link rel="stylesheet" type="text/css" href="//cdn.datatables.net/1.10.12/css/jquery.dataTables.css">

  

<script type="text/javascript" charset="utf8" src="//cdn.datatables.net/1.10.12/js/jquery.dataTables.js"></script>
<script type="text/javascript">
var hostname=window.location.hostname;
var mysitesLink='http://vaww.mysites.' + hostname.substring(5);
               var hostweburl="/sites/IRBApplications";
               var applicationList = new Array();
			   var isMember = false;

               
    // Load the required SharePoint libraries.
    $(document).ready(function () {                             
                // Get the URI decoded URLs.
       //hostweburl = decodeURIComponent(getQueryStringParameter("SPHostUrl"));

        // The js files are in a URL in the form:
        // web_url/_layouts/15/resource_file
        var scriptbase = hostweburl + "/_layouts/15/";

        // Load the js files and continue to
        // the execOperation function.
        $.getScript(scriptbase + "SP.Runtime.js",
            function () {
                $.getScript(scriptbase + "SP.js", execOperation);
            }
        );

        //Function to execute basic operations.

        function execOperation() {

            // get context and then username

            context = new SP.ClientContext.get_current();

            web = context.get_web();
            
            CheckCurrentUserMembership();

        }
    
    });

function CheckCurrentUserMembership() {

    var clientContext = new SP.ClientContext.get_current();
    this.currentUser = clientContext.get_web().get_currentUser();
    clientContext.load(this.currentUser);

    this.userGroups = this.currentUser.get_groups();
    clientContext.load(this.userGroups);
    clientContext.executeQueryAsync(onCheckCurrentUserMembershipQuerySucceeded);
}

function onCheckCurrentUserMembershipQuerySucceeded() {
         var groupsEnumerator = userGroups.getEnumerator();
          while (groupsEnumerator.moveNext()) {
             var group= groupsEnumerator.get_current();
             var webTitle= _spPageContextInfo.webTitle;
			 var administratorGroupName=webTitle + " RDC Administrators";
			 if(group.get_title() == administratorGroupName) {
                 isMember = true;
                 break;
             }
			 
          }
		  
		
		if (isMember) {
			
		retrieveApplicationListItems(hostweburl);
		 }

}


  // Function to retrieve a query string value.
    // For production purposes you may want to use
    // a library to handle the query string.
    function getQueryStringParameter(paramToRetrieve) {
        var params =
            document.URL.split("?")[1].split("&");
        var strParams = "";
        for (var i = 0; i < params.length; i = i + 1) {
            var singleParam = params[i].split("=");
            if (singleParam[0] == paramToRetrieve)
                return singleParam[1];
        }
    }


function retrieveApplicationListItems(siteurl) {
    var clientContext = new SP.ClientContext(siteurl);
    var aList = clientContext.get_web().get_lists().getByTitle('Application');
        
    var camlQuery = new SP.CamlQuery();
   
camlQuery.set_viewXml('<View><Query><Where><Contains><FieldRef Name="ApplicationStatus"/><Value Type="Text">Approved</Value></Contains><Or><Or><Membership Type=\CurrentUserGroups\><FieldRef Name=\VisibleToGroup\/></Membership><Eq><FieldRef Name=\VisibleToGroup\/><Value Type=\Integer\><UserID/></Value></Eq></Or><Eq><FieldRef Name=\Author\/><Value Type=\Integer\><UserID /></Value></Eq></Or></Where></Query></View>'); 


    this.collListItem = aList.getItems(camlQuery);
        
    clientContext.load(collListItem);
    clientContext.executeQueryAsync(
        Function.createDelegate(this, this.onQuerySucceeded), 
        Function.createDelegate(this, this.onQueryFailed)
    ); 
}

function Application (studyIdLink, studyTitle, principalInvestigator, applicationType, applicationStatus, renewalDate) {

               this.studyIdLink=studyIdLink;
               this.studyTitle=studyTitle;
               this.principalInvestigator=principalInvestigator;
               this.applicationType= applicationType;
               this.applicationStatus=applicationStatus; 
               this.renewalDate=renewalDate; 
               
}




function onQuerySucceeded(sender, args) {
    var listItemEnumerator = this.collListItem.getEnumerator();
        
    while (listItemEnumerator.moveNext()) {
               var aListItem = listItemEnumerator.get_current();
                
                  var studyIdLink=aListItem.get_item("StudyIDLink");             
                  var studyTitle =aListItem.get_item("StudyTitle");
                  var principalInvestigator = aListItem.get_item("PrincipalInvestigator");
                  var principalInvestigatorName="";
                  
               if (principalInvestigator!=null) {
                principalInvestigatorName=principalInvestigator.get_lookupValue();
              }
          
               var principalInvestigatorNameLink="<a href=" + this.mysitesLink;		
               principalInvestigatorNameLink+= ">" + principalInvestigatorName + "</a>";			  
                var applicationType =aListItem.get_item("ApplicationType");
                var applicationStatus= aListItem.get_item("ApplicationStatus");
                var renewalDate=aListItem.get_item("RenewalDate");
                //var iacucOversightRequired=aListItem.get_item("IACUCRequired");
                var newApplication=new Application(studyIdLink, studyTitle, principalInvestigatorNameLink, applicationType, applicationStatus, renewalDate); 
                                               
                applicationList.push(newApplication);
			  
                 
     }
       
  
$('#applicationList').DataTable( {

    data: applicationList,

    columns: [
                 { data: 'studyIdLink' },
                { data: 'studyTitle' },
                { data: 'principalInvestigator' },
                { data: 'applicationType' },
                { data: 'applicationStatus' },
                { data: 'renewalDate' }
           




        
    ]

} );


}


function onQueryFailed(sender, args) {
    alert('Request failed. ' + args.get_message() + 
        '\n' + args.get_stackTrace());
}

</script>

<table id="applicationList" class="display">
<thead>
               <tr>
                              <th>StudyIDLink</th>
                              <th>Study Title</th>
                              <th>Principal Investigator</th>
                              <th>Application Type</th>
                              <th>Application Status</th>
                              <th>Renewal Date</th>
                              
               </tr>
               </thead>
</table>