/* Note: Modify the location path in three places within the script that are highlighted in bold Red to reflect the proper location of the following items:
	Current location of backup file shown as N'D:\IntegrationReleaseBackups\503\SP_RAMS_WSS_Content_IRB_Application_DB_2_0_0503.FUL'  (Make sure to select correct backup file SP_RAMS_WSS_Content_IRB_Application_DB_2_0_0503.FUL).
	Data file location shown as N'E:\Microsoft SQL Server\MSSQL\Data\SP_RAMS_WSS_Content_IRB_Application_DB_2_0.mdf'. (.mdf file location)
	Log file location shown as N'L:\Microsoft SQL Server\MSSQL\Data\SP_RAMS_WSS_Content_IRB_Application_DB_log_2_0.LDF'. (.LDF file location)*/
USE master 
GO

Restore database [SP_RAMS_WSS_Content_IRB_Application_DB_2_0] 
FROM DISK = N'D:\IntegrationReleaseBackups\503\SP_RAMS_WSS_Content_IRB_Application_DB_2_0_0503.FUL' 
WITH FILE = 1, 
MOVE N'SP_RAMS_WSS_Content_IRB_Applications_DB' 
TO N'E:\Microsoft SQL Server\MSSQL\Data\SP_RAMS_WSS_Content_IRB_Application_DB_2_0.mdf', 
MOVE N'SP_RAMS_WSS_Content_IRB_Applications_DB_log' 
TO N'L:\Microsoft SQL Server\MSSQL\Data\SP_RAMS_WSS_Content_IRB_Application_DB_log_2_0.LDF', 
NOUNLOAD, STATS =5 

GO