﻿<script src="/sites/IRBApplications/SiteAssets/js/docxtemplater.js"></script>
<script src="/sites/IRBApplications/SiteAssets/js/FileSaver.min.js"></script>
<script src="/sites/IRBApplications/SiteAssets/js/jszip-utils.js"></script>
// <script
// src="https://vaww.itst.ram.msp.DNS   /SiteAssets/js/dynamicGeneration.js"></script>
<script src="/sites/IRBApplications/SiteAssets/js/jquery-1.8.3.min.js"></script>

<script src="/sites/IRBApplications/SiteAssets/js/spin.min.js"></script>
// <script
// src="/sites/IRBApplications/SiteAssets/js/jshashtable-3.0.js"></script>
// <script
// src="/sites/IRBApplications/SiteAssets/js/rams-environment.js"></script>

// <script
// src="/sites/IRBApplications/SiteAssets/js/dynamicMembers.js"></script>
<script src="/sites/IRBApplications/SiteAssets/js/MicrosoftAjax.js"></script> 
<script src="/sites/IRBApplications/SiteAssets/js/moment.js"></script>
// <script type="text/javascript" src="_layouts/15/sp.runtime.js"></script>
// <script type="text/javascript" src="_layouts/15/sp.js"></script>
<!--
Mandatory in IE 6, 7, 8 and 9.
-->
<!--[if IE]>
<script type="text/javascript" src="examples/vendor/jszip-utils-ie.js"></script>
<![endif]-->

<div id="spinnerdiv"> </div>
<script>
var loadFile=function(url,callback){
	JSZipUtils.getBinaryContent(url,callback);
}
var opts = {
		lines: 12, // The number of lines to draw
		length: 7, // The length of each line
		width: 5, // The line thickness
		radius: 10, // The radius of the inner circle
		color: '#fff', // #rbg or #rrggbb
		speed: 1, // Rounds per second
		trail: 66, // Afterglow percentage
		shadow: true // Whether to render a shadow
};

// checkSourceParameter();
var target = document.getElementById('spinnerdiv');

var spinner = new Spinner(opts).spin(target);
$(target).data('spinner',spinner);

var itemInfo; // data after JSON is parsed into dictionary
var currentUrl = window.location.href;
var studyArray = [];
var minuteArray=[];
var agendaColumns = new Object;
var committeeName="";
var committeeListUrl="";
var agendaMinutesTitle="";


generateAgendaReport(currentUrl);

function generateAgendaReport(currUrl){
	var realUrl = currUrl.substring(0, currUrl.indexOf("SitePages")-1);
	var itemID  = getQueryStringParameter('CustomID');// currUrl.substring(currUrl.indexOf("ID=")+3);
	var listUrl="";
	committeeName = getQueryStringParameter('committeeName');
	
	if (committeeName=="RDC") {
		committeeListUrl=realUrl + "/_api/web/lists/getbytitle('RDC Calendar')/items(" + itemID + ")?$select=Title,EventDate,CommitteeAttendees/ID,CommitteeAttendees/Title,ParticipantsPicker/ID,ParticipantsPicker/Title,ApprovedRDCApplicationLookup/ID&$expand=CommitteeAttendees,ApprovedRDCApplicationLookup,ParticipantsPicker";
		agendaMinutesTitle="RDC";
	} else if (committeeName=="IACUC") {
		committeeListUrl=realUrl + "/_api/web/lists/getbytitle('IACUC Calendar')/items(" + itemID + ")?$select=Title,EventDate,ParticipantsPicker/ID,ParticipantsPicker/Title,CommitteeAttendees/ID,CommitteeAttendees/Title,IACUCApplicationLookup/ID,IACUCMinuteLookup/ID&$expand=ParticipantsPicker,IACUCApplicationLookup,CommitteeAttendees,IACUCMinuteLookup";
		agendaMinutesTitle="IRB";
	} 
	else {
		console.log('Committee Was Not Figured Correctly');
	}
	$.ajax({
		//url: realUrl + "/_api/web/lists/getbytitle('IACUC Calendar')/items(" + itemID + ")?$select=Title,EventDate,ParticipantsPicker/ID,ParticipantsPicker/Title,CommitteeAttendees/ID,CommitteeAttendees/Title,IACUCApplicationLookup/ID,IACUCMinuteLookup/ID&$expand=ParticipantsPicker,IACUCApplicationLookup,CommitteeAttendees,IACUCMinuteLookup",		
		url: committeeListUrl,
		method: "GET",
		headers: { "Accept": "application/json; odata=verbose" },
		success: function (data) {
			// mapping the results
			mapDataObject(data);
		},
		error: function (data) {
			alert(data.responseText);
		}
	});

	// console.log(agendaColumns);
	// return agendaColumns;
	// return itemInfo;
}


function mapDataObject(inData){
	itemInfo =  inData;
	var arr = [];


	var committeeAttendeeCount = 0;
	var attendeeCount = 0;
	agendaColumns["Title"] = itemInfo.d.Title; // can also use
												// agendaColumns.Title to add
												// property to object
	// agendaColumns["Location"] = itemInfo[0].Location;
	agendaColumns["EventDate"] = moment(itemInfo.d.EventDate).format( "MMM DD YYYY"); // no
																						// 'StartDate'
																						// value
																						// found
	agendaColumns["EventTime"] = moment(itemInfo.d.EventDate).format( "h:mm");
	// agendaColumns["Description"] = itemInfo[0].Description;
	// agendaColumns["Date Created"] = itemInfo[0].Created;
	if (itemInfo.d.CommitteeAttendees.hasOwnProperty('results')){
		committeeAttendeeCount = itemInfo.d.CommitteeAttendees.results.length;
		for(count = 0; count < committeeAttendeeCount; count++){
			arr.push({
				"name": itemInfo.d.CommitteeAttendees.results[count].Title,
				"role": "N/A",
				"coi": "No"
			});

		}
	}
	if (itemInfo.d.ParticipantsPicker.hasOwnProperty('results')){
		attendeeCount = itemInfo.d.ParticipantsPicker.results.length;
		for(count = 0; count < attendeeCount; count++){
			arr.push({
				"name": itemInfo.d.ParticipantsPicker.results[count].Title,
				"role": "N/A",
				"coi": "No"
			});

		}
	}
	agendaColumns["Attendees"] = arr; // of type Collection
	agendaColumns["CommitteeAttendeeCount"] = committeeAttendeeCount;
	agendaColumns["AttendeeCount"] = attendeeCount
	processMinutes(itemInfo);
}

function processStudies(itemInfo){
	studies = itemInfo.d.ApprovedRDCApplicationLookup.results; 
	if (studies.length > 0){
		for(count = 0; count < studies.length;count++){

			var studyID = studies[count].ID;
			var studyResult= getStudy(studyID);
			studyResult.done(function(result) {
				// result is an SP.List because that is what we passed to
				// resolve()!
				var study = result; 
				var AssignedIRBAdministrator;
				if (study.d.AssignedIRBAdministrator.hasOwnProperty('Title')){

					AssignedIRBAdministrator = study.d.AssignedIRBAdministrator.Title;
				}
				else{

					AssignedIRBAdministrator = "N/A";
				}
				var PrimaryReviewer;
				if (study.d.PrimaryReviewers.hasOwnProperty('results')){

					PrimaryReviewer = study.d.PrimaryReviewers.results[0].Title;// Will
																				// Modify
																				// code
																				// to
																				// accomodate
																				// more
																				// than
																				// one
																				// reviewer
				}
				else{

					AssignedIRBAdministrator = "N/A";
				}
				studyArray.push({
					"StudyTitle": study.d.StudyTitle,
					"StudyID": study.d.Study_ID,
					"PI": study.d.PrincipalInvestigator.Title,
					"PrimaryReviewer":PrimaryReviewer,
					"IRBAdmin":AssignedIRBAdministrator,
					"Deliberation":study.d.Deliberation,
					"Decision": study.d.Decision,
					"StudyType":study.d.ApplicationType
				});
				
				if (committeeName=="RDC") {
					if (studyArray.length == itemInfo.d.ApprovedRDCApplicationLookup.results.length ){
						agendaColumns["Studies"]=studyArray;  

						generateDocx(agendaColumns);

					}
					
				} else if (committeeName=="IACUC") {
					if (studyArray.length == itemInfo.d.IACUCApplicationLookup.results.length ){
						agendaColumns["Studies"]=studyArray;  

						generateDocx(agendaColumns);

					}
				} 
				else {
					console.log('Committee Was Not Figured Correctly');
				}
				
			});

			studyResult.fail(function(result) {
				// result is a string because that is what we passed to
				// reject()!
				var error = result;
				console.log(error);

			});


		}
	}
	else{  // no studies attached

		generateDocx(agendaColumns);
	}

}
function processMinutes(itemInfo){
	// 468161: Fix the issue of generate agenda report in RDC Meetings list
	// Uses Calendar as source instead of meeting minut
	minuteArray.push({
		"minuteTitle": itemInfo.Title,
		"discussion": itemInfo.Deliberation,
		"action": itemInfo.Decision
	});
	agendaColumns["Minutes"]=minuteArray;  

	processStudies(itemInfo);



}
function generateDocx(dataSet){

	var AttendeeArray = dataSet["Attendees"];
	var agendaDate = dataSet["EventDate"];
	var agendaTime = dataSet["EventTime"];
	var agendaStudies = dataSet["Studies"];
	var agendaMinutes = dataSet["Minutes"];
	var committeeAttendeeCount = dataSet["CommitteeAttendeeCount"];
	var attendeeCount = dataSet["AttendeeCount"];
	
	loadFile("/sites/IRBApplications/SiteAssets/js/Agenda-Minutes-Template.docx",function(err,content){
		doc=new Docxtemplater(content)
		var clientArray = [{"name":"John Smith", "role":"Developer", "coi":"Yes"},{"name":"Kang Cho", "role":"Principle", "coi":"No"}];
		doc.setData({
			"AgendaMinutesTitle":agendaMinutesTitle,
			"attendee":AttendeeArray,
			"CommitteeAttendeeCount": committeeAttendeeCount,
			"AttendeeCount":attendeeCount,
			"date":agendaDate,
			"time":agendaTime,
			"Studies":agendaStudies,
			"Minutes":agendaMinutes
		});
		doc.render() // apply them
		output=doc.getZip().generate({type:"blob"}) // Output the document using
													// Data-URI
		saveAs(output,"Agenda-Minutes-"+agendaDate+".docx");
		$('#spinnerdiv').data('spinner').stop();
	})



}

function checkSourceParameter(){
	var sourceParam = getQueryStringParameter('Source');
	if (sourceParam == null || sourceParam == '' ){
		var thisUrl = window.location.href;
		var siteUrl = thisUrl.substring(0, thisUrl.indexOf("Lists")-1);
		window.location.href = URL_add_parameter(thisUrl, 'Source', siteUrl);
	}
}
function getStudy(inStudyID){
	var d = $.Deferred(); 
	var realUrl = currentUrl.substring(0, currentUrl.indexOf("SitePages")-1);
	$.ajax({
		url: realUrl + "/_api/web/lists/getbytitle('Committee Topics')/items(" + inStudyID + ")?$select=StudyTitle,ApplicationType,Study_ID,Deliberation, PrincipalInvestigator/ID, PrincipalInvestigator/Title,PrimaryReviewers/ID, PrimaryReviewers/Title, Reviewers/ID, Reviewers/Title, AssignedIRBAdministrator/ID, AssignedIRBAdministrator/Title&$expand=PrincipalInvestigator, PrimaryReviewers, Reviewers, AssignedIRBAdministrator",
		method: "GET",
		headers: { "Accept": "application/json; odata=verbose" },
		success: function (data) {

			d.resolve(data);
		},
		error: function (data) {
			// alert(data);
			d.reject("getStudyFailed");
		}
	});
	return d.promise();
}

function getMinute(inMinutesID){
	var d = $.Deferred(); 
	var realUrl = currentUrl.substring(0, currentUrl.indexOf("SitePages")-1);
	$.ajax({
		url: realUrl + "/_api/web/lists/getbytitle('CommitteeMinutes')/items(" + inMinutesID + ")?$select=Title,Deliberation, Decision",
		method: "GET",
		headers: { "Accept": "application/json; odata=verbose" },
		success: function (data) {

			d.resolve(data);
		},
		error: function (data) {
			// alert(data);
			d.reject("getMinutesFailed");
		}
	});
	return d.promise();
}
function getQueryStringParameter(urlParameterKey) {

	var params = document.URL.split('?')[1].split('&');
	var strParams = '';

	for (var i = 0; i < params.length; i = i + 1) {
		var singleParam = params[i].split('=');
		if (singleParam[0] == urlParameterKey)
			return decodeURIComponent(singleParam[1]);

	}

}

function URL_add_parameter(url, param, value){
	var hash       = {};
	var parser     = document.createElement('a');

	parser.href    = url;

	var parameters = parser.search.split(/\?|&/);

	for(var i=0; i < parameters.length; i++) {
		if(!parameters[i])
			continue;

		var ary      = parameters[i].split('=');
		hash[ary[0]] = ary[1];
	}

	hash[param] = value;

	var list = [];  
	Object.keys(hash).forEach(function (key) {
		list.push(key + '=' + hash[key]);
	});

	parser.search = '?' + list.join('&');
	return parser.href;
}

</script>