/*
Note: Modify the location path in two places within the script to reflect the proper location of the following items:
	Current location of backup file shown as N'D:\2-0_Backups\SP_RAMS_WSS_Content_IRB_Applications_DB_backup_Prod_Full.bak'  (Make sure to select correct location in 'TO  DISK' line).
	current location of backup file shown as N'D:\2-0_Backups\SP_RAMS_WSS_Content_IRB_Applications_DB_backup_Prod_Full.bak'. (in 'RESTORE VERIFYONLY FROM  DISK ' line)
*/

BACKUP DATABASE [SP_RAMS_WSS_Content_IRB_Applications_DB] 
TO  DISK = N'D:\2-0_Backups\SP_RAMS_WSS_Content_IRB_Applications_DB_backup_Prod_Full.bak' 
WITH NOFORMAT, NOINIT,  NAME = N'SP_RAMS_WSS_Content_IRB_Applications_DB-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset 
where database_name=N'SP_RAMS_WSS_Content_IRB_Applications_DB' 
and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'SP_RAMS_WSS_Content_IRB_Application_DB' )
if @backupSetId is null begin raiserror(N'Verify failed. Backup information for database ''SP_RAMS_WSS_Content_IRB_Applications_DB'' not found.', 16, 1) end
RESTORE VERIFYONLY 
FROM  DISK = N'D:\2-0_Backups\SP_RAMS_WSS_Content_IRB_Applications_DB_backup_Prod_Full.bak' 
WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO
