USE [master]
GO
/****** Object:  Database [RAMS]    Script Date: 11/4/2016 10:23:21 AM 
MAKE SURE TO MODIFY THE DIRECTORY OF DATA AND LOG FILE ON LINE #8 & #10 ******/
CREATE DATABASE [RAMS]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'RAMS', FILENAME = N'G:\Program Files\Microsoft SQL Server\Data\RAMS.mdf' , SIZE = 51200KB , MAXSIZE = 524380160KB , FILEGROWTH = 20480KB )
 LOG ON 
( NAME = N'RAMS_log', FILENAME = N'L:\Program Files\Microsoft SQL Server\Logs\RAMS_log.LDF' , SIZE = 43264KB , MAXSIZE = 262144000KB , FILEGROWTH = 10240KB)
GO
ALTER DATABASE [RAMS] SET COMPATIBILITY_LEVEL = 110
GO
IF (1 = FULLTEXTSERVICEPROPERTY('IsFullTextInstalled'))
begin
EXEC [RAMS].[dbo].[sp_fulltext_database] @action = 'enable'
end
GO
ALTER DATABASE [RAMS] SET ANSI_NULL_DEFAULT OFF 
GO
ALTER DATABASE [RAMS] SET ANSI_NULLS OFF 
GO
ALTER DATABASE [RAMS] SET ANSI_PADDING OFF 
GO
ALTER DATABASE [RAMS] SET ANSI_WARNINGS OFF 
GO
ALTER DATABASE [RAMS] SET ARITHABORT OFF 
GO
ALTER DATABASE [RAMS] SET AUTO_CLOSE OFF 
GO
ALTER DATABASE [RAMS] SET AUTO_CREATE_STATISTICS ON 
GO
ALTER DATABASE [RAMS] SET AUTO_SHRINK OFF 
GO
ALTER DATABASE [RAMS] SET AUTO_UPDATE_STATISTICS ON 
GO
ALTER DATABASE [RAMS] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO
ALTER DATABASE [RAMS] SET CURSOR_DEFAULT  GLOBAL 
GO
ALTER DATABASE [RAMS] SET CONCAT_NULL_YIELDS_NULL OFF 
GO
ALTER DATABASE [RAMS] SET NUMERIC_ROUNDABORT OFF 
GO
ALTER DATABASE [RAMS] SET QUOTED_IDENTIFIER OFF 
GO
ALTER DATABASE [RAMS] SET RECURSIVE_TRIGGERS OFF 
GO
ALTER DATABASE [RAMS] SET  DISABLE_BROKER 
GO
ALTER DATABASE [RAMS] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO
ALTER DATABASE [RAMS] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO
ALTER DATABASE [RAMS] SET TRUSTWORTHY OFF 
GO
ALTER DATABASE [RAMS] SET ALLOW_SNAPSHOT_ISOLATION OFF 
GO
ALTER DATABASE [RAMS] SET PARAMETERIZATION SIMPLE 
GO
ALTER DATABASE [RAMS] SET READ_COMMITTED_SNAPSHOT OFF 
GO
ALTER DATABASE [RAMS] SET HONOR_BROKER_PRIORITY OFF 
GO
ALTER DATABASE [RAMS] SET RECOVERY FULL 
GO
ALTER DATABASE [RAMS] SET  MULTI_USER 
GO
ALTER DATABASE [RAMS] SET PAGE_VERIFY CHECKSUM  
GO
ALTER DATABASE [RAMS] SET DB_CHAINING OFF 
GO
ALTER DATABASE [RAMS] SET FILESTREAM( NON_TRANSACTED_ACCESS = OFF ) 
GO
ALTER DATABASE [RAMS] SET TARGET_RECOVERY_TIME = 0 SECONDS 
GO
EXEC sys.sp_db_vardecimal_storage_format N'RAMS', N'ON'
GO
