USE RAMStest
GO
/******ESTABLISH RELATIONSHIP 
Object:  Index [IX_Study_Status]    Script Date: 11/4/2016 10:23:22 AM ******/
ALTER TABLE [dbo].[Study_Status] ADD  CONSTRAINT [IX_Study_Status] UNIQUE NONCLUSTERED 
(
	[StudyStatusID] ASC,
	[StageCounter] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
ALTER TABLE [dbo].[Answers]  WITH CHECK ADD  CONSTRAINT [Questions_Answers_FK1] FOREIGN KEY([QuestionsID])
REFERENCES [dbo].[Questions] ([QuestionsID])
GO
ALTER TABLE [dbo].[Answers] CHECK CONSTRAINT [Questions_Answers_FK1]
GO
ALTER TABLE [dbo].[Contained_Forms]  WITH CHECK ADD  CONSTRAINT [FK_Contained_Forms_Answers] FOREIGN KEY([RequiredPredecessorAnswersID])
REFERENCES [dbo].[Answers] ([AnswersID])
GO
ALTER TABLE [dbo].[Contained_Forms] CHECK CONSTRAINT [FK_Contained_Forms_Answers]
GO
ALTER TABLE [dbo].[Contained_Forms]  WITH CHECK ADD  CONSTRAINT [FK_Contained_Forms_Forms] FOREIGN KEY([ContainerID])
REFERENCES [dbo].[Forms] ([FormsID])
GO
ALTER TABLE [dbo].[Contained_Forms] CHECK CONSTRAINT [FK_Contained_Forms_Forms]
GO
ALTER TABLE [dbo].[Contained_Forms]  WITH CHECK ADD  CONSTRAINT [FK_Contained_Forms_Forms1] FOREIGN KEY([ContentID])
REFERENCES [dbo].[Forms] ([FormsID])
GO
ALTER TABLE [dbo].[Contained_Forms] CHECK CONSTRAINT [FK_Contained_Forms_Forms1]
GO
ALTER TABLE [dbo].[Contained_Forms]  WITH CHECK ADD  CONSTRAINT [FK_Contained_Forms_Questions] FOREIGN KEY([RequiredPredecessorQuestionsID])
REFERENCES [dbo].[Questions] ([QuestionsID])
GO
ALTER TABLE [dbo].[Contained_Forms] CHECK CONSTRAINT [FK_Contained_Forms_Questions]
GO
ALTER TABLE [dbo].[Form_Comments]  WITH CHECK ADD  CONSTRAINT [FK_Form_Comments_Forms] FOREIGN KEY([FormsID])
REFERENCES [dbo].[Forms] ([FormsID])
GO
ALTER TABLE [dbo].[Form_Comments] CHECK CONSTRAINT [FK_Form_Comments_Forms]
GO
ALTER TABLE [dbo].[Form_Comments]  WITH CHECK ADD  CONSTRAINT [FK_Form_Comments_Study_Status] FOREIGN KEY([StudyStatusID])
REFERENCES [dbo].[Study_Status] ([StudyStatusID])
GO
ALTER TABLE [dbo].[Form_Comments] CHECK CONSTRAINT [FK_Form_Comments_Study_Status]
GO
ALTER TABLE [dbo].[Form_Comments]  WITH CHECK ADD  CONSTRAINT [FK_Form_Comments_Users] FOREIGN KEY([UsersID])
REFERENCES [dbo].[Users] ([UsersID])
GO
ALTER TABLE [dbo].[Form_Comments] CHECK CONSTRAINT [FK_Form_Comments_Users]
GO
ALTER TABLE [dbo].[Form_Versions]  WITH CHECK ADD  CONSTRAINT [FK_Form_Versions_Forms] FOREIGN KEY([RootFormsID])
REFERENCES [dbo].[Forms] ([FormsID])
GO
ALTER TABLE [dbo].[Form_Versions] CHECK CONSTRAINT [FK_Form_Versions_Forms]
GO
ALTER TABLE [dbo].[Forms_Questions]  WITH CHECK ADD  CONSTRAINT [FK_Forms_Questions_Answers] FOREIGN KEY([RequiredPredecessorAnswersID])
REFERENCES [dbo].[Answers] ([AnswersID])
GO
ALTER TABLE [dbo].[Forms_Questions] CHECK CONSTRAINT [FK_Forms_Questions_Answers]
GO
ALTER TABLE [dbo].[Forms_Questions]  WITH CHECK ADD  CONSTRAINT [Forms_Forms_Questions_FK1] FOREIGN KEY([FormsID])
REFERENCES [dbo].[Forms] ([FormsID])
GO
ALTER TABLE [dbo].[Forms_Questions] CHECK CONSTRAINT [Forms_Forms_Questions_FK1]
GO
ALTER TABLE [dbo].[Forms_Questions]  WITH CHECK ADD  CONSTRAINT [Questions_Forms_Questions_FK1] FOREIGN KEY([QuestionsID])
REFERENCES [dbo].[Questions] ([QuestionsID])
GO
ALTER TABLE [dbo].[Forms_Questions] CHECK CONSTRAINT [Questions_Forms_Questions_FK1]
GO
ALTER TABLE [dbo].[Forms_Questions]  WITH CHECK ADD  CONSTRAINT [Questions_Forms_Questions_FK2] FOREIGN KEY([RequiredPredecessorQuestionsID])
REFERENCES [dbo].[Questions] ([QuestionsID])
GO
ALTER TABLE [dbo].[Forms_Questions] CHECK CONSTRAINT [Questions_Forms_Questions_FK2]
GO
ALTER TABLE [dbo].[Question_Comments]  WITH CHECK ADD  CONSTRAINT [FK_Question_Comments_Questions] FOREIGN KEY([QuestionsID])
REFERENCES [dbo].[Questions] ([QuestionsID])
GO
ALTER TABLE [dbo].[Question_Comments] CHECK CONSTRAINT [FK_Question_Comments_Questions]
GO
ALTER TABLE [dbo].[Question_Comments]  WITH CHECK ADD  CONSTRAINT [FK_Question_Comments_Study_Status] FOREIGN KEY([StudyStatusID])
REFERENCES [dbo].[Study_Status] ([StudyStatusID])
GO
ALTER TABLE [dbo].[Question_Comments] CHECK CONSTRAINT [FK_Question_Comments_Study_Status]
GO
ALTER TABLE [dbo].[Question_Comments]  WITH CHECK ADD  CONSTRAINT [FK_Question_Comments_Users] FOREIGN KEY([UsersID])
REFERENCES [dbo].[Users] ([UsersID])
GO
ALTER TABLE [dbo].[Question_Comments] CHECK CONSTRAINT [FK_Question_Comments_Users]
GO
ALTER TABLE [dbo].[Questions]  WITH CHECK ADD  CONSTRAINT [Response_Formats_Questions_FK1] FOREIGN KEY([ResponseFormatsID])
REFERENCES [dbo].[Response_Formats] ([ResponseFormatsID])
GO
ALTER TABLE [dbo].[Questions] CHECK CONSTRAINT [Response_Formats_Questions_FK1]
GO
ALTER TABLE [dbo].[Questions_Responses]  WITH CHECK ADD  CONSTRAINT [Answers_Question_Responses_FK1] FOREIGN KEY([AnswersID])
REFERENCES [dbo].[Answers] ([AnswersID])
GO
ALTER TABLE [dbo].[Questions_Responses] CHECK CONSTRAINT [Answers_Question_Responses_FK1]
GO
ALTER TABLE [dbo].[Questions_Responses]  WITH CHECK ADD  CONSTRAINT [FK_Questions_Responses_Study_Status] FOREIGN KEY([StudyStatusID])
REFERENCES [dbo].[Study_Status] ([StudyStatusID])
GO
ALTER TABLE [dbo].[Questions_Responses] CHECK CONSTRAINT [FK_Questions_Responses_Study_Status]
GO
ALTER TABLE [dbo].[Questions_Responses]  WITH CHECK ADD  CONSTRAINT [Forms_Questions_Question_Responses_FK1] FOREIGN KEY([QuestionsID])
REFERENCES [dbo].[Questions] ([QuestionsID])
GO
ALTER TABLE [dbo].[Questions_Responses] CHECK CONSTRAINT [Forms_Questions_Question_Responses_FK1]
GO
ALTER TABLE [dbo].[Studies]  WITH CHECK ADD  CONSTRAINT [FK_Studies_Facilities] FOREIGN KEY([FacilitiesID])
REFERENCES [dbo].[Facilities] ([FacilitiesID])
GO
ALTER TABLE [dbo].[Studies] CHECK CONSTRAINT [FK_Studies_Facilities]
GO
ALTER TABLE [dbo].[Studies]  WITH CHECK ADD  CONSTRAINT [FK_Studies_Form_Versions] FOREIGN KEY([FormVersionsID])
REFERENCES [dbo].[Form_Versions] ([FormVersionsID])
GO
ALTER TABLE [dbo].[Studies] CHECK CONSTRAINT [FK_Studies_Form_Versions]
GO
ALTER TABLE [dbo].[Studies]  WITH CHECK ADD  CONSTRAINT [FK_Studies_Studies] FOREIGN KEY([ParentStudiesID])
REFERENCES [dbo].[Studies] ([StudiesID])
GO
ALTER TABLE [dbo].[Studies] CHECK CONSTRAINT [FK_Studies_Studies]
GO
ALTER TABLE [dbo].[Study_Members]  WITH CHECK ADD  CONSTRAINT [FK__Study_Mem__Studi__75A278F5] FOREIGN KEY([StudiesID])
REFERENCES [dbo].[Studies] ([StudiesID])
GO
ALTER TABLE [dbo].[Study_Members] CHECK CONSTRAINT [FK__Study_Mem__Studi__75A278F5]
GO
ALTER TABLE [dbo].[Study_Members]  WITH CHECK ADD  CONSTRAINT [FK__Study_Mem__Users__76969D2E] FOREIGN KEY([UsersID])
REFERENCES [dbo].[Users] ([UsersID])
GO
ALTER TABLE [dbo].[Study_Members] CHECK CONSTRAINT [FK__Study_Mem__Users__76969D2E]
GO
ALTER TABLE [dbo].[Study_Status]  WITH CHECK ADD  CONSTRAINT [FK_Study_Status_Studies] FOREIGN KEY([StudiesID])
REFERENCES [dbo].[Studies] ([StudiesID])
GO
ALTER TABLE [dbo].[Study_Status] CHECK CONSTRAINT [FK_Study_Status_Studies]
GO
ALTER TABLE [dbo].[Study_Status]  WITH CHECK ADD  CONSTRAINT [FK_Study_Status_Study_States] FOREIGN KEY([StudyStatesID])
REFERENCES [dbo].[Study_States] ([StudyStatesID])
GO
ALTER TABLE [dbo].[Study_Status] CHECK CONSTRAINT [FK_Study_Status_Study_States]
GO
ALTER TABLE [dbo].[Study_Status]  WITH CHECK ADD  CONSTRAINT [FK_Study_Status_Users] FOREIGN KEY([CreatedBy])
REFERENCES [dbo].[Users] ([UsersID])
GO
ALTER TABLE [dbo].[Study_Status] CHECK CONSTRAINT [FK_Study_Status_Users]
GO
ALTER TABLE [dbo].[Study_Status]  WITH CHECK ADD  CONSTRAINT [FK_Study_Status_Users1] FOREIGN KEY([UpdatedBy])
REFERENCES [dbo].[Users] ([UsersID])
GO
ALTER TABLE [dbo].[Study_Status] CHECK CONSTRAINT [FK_Study_Status_Users1]
GO
ALTER TABLE [dbo].[Study_Status_Reviewers]  WITH CHECK ADD  CONSTRAINT [FK_Study_Status_Reviewers_Study_Status] FOREIGN KEY([StudyStatusID])
REFERENCES [dbo].[Study_Status] ([StudyStatusID])
GO
ALTER TABLE [dbo].[Study_Status_Reviewers] CHECK CONSTRAINT [FK_Study_Status_Reviewers_Study_Status]
GO
ALTER TABLE [dbo].[Study_Status_Reviewers]  WITH CHECK ADD  CONSTRAINT [FK_Study_Status_Reviewers_Users] FOREIGN KEY([UsersID])
REFERENCES [dbo].[Users] ([UsersID])
GO
ALTER TABLE [dbo].[Study_Status_Reviewers] CHECK CONSTRAINT [FK_Study_Status_Reviewers_Users]
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'0-based index for multiple answers as part of the same response' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Questions_Responses', @level2type=N'COLUMN',@level2name=N'CheckboxIndex'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Questions_Responses'
GO
