USE RAMS
GO
Update dbo.questions
set questionHyperText ='Will results of specific tests and/or results of the overall study be revealed to the research subject or to his or her healthcare provider?'
where questionsID=13625

USE RAMS
GO
Update dbo.questions
set questionHyperText ='If a subject withdraws from the study or revokes authorization, what happens to his or her specimen and the data obtained from his or her specimen?'
where questionsID=13344

USE RAMS
GO
Update dbo.questions
set questionHyperText ='Does the research include procedures or tests that are purposed for research, as opposed to usual clinical care?'
where questionsID=13641

USE RAMS
GO
Update dbo.questions
set questionHyperText ='Are there any possible advantages to the prisoner from his/her participation in the research, when compared to the general living conditions, medical care, quality of food, amenities, and opportunity for earnings in the prison, that would impair the participants ability to weigh the risks of the research against the value of such advantages?'
where questionsID=13320

USE RAMS
GO
Update dbo.questions
set questionHyperText ='What is the basis for including individuals with impaired decision making capacity?'
where questionsID=13335

USE RAMS
GO
Update dbo.questions
set questionHyperText ='Will the research be conducted outside of the United States?'
where questionsID=13642

USE RAMS
GO
Update dbo.questions
set questionHyperText ='Will there be a Data Use Agreement (or for a contractor a Business Associate Agreement) that will need to be obtained?'
where questionsID=13438

USE RAMS
GO
Update dbo.questions
set questionHyperText ='Is VASI stored on a local computer hard drive (even temporarily) such as specially obtained software?'
where questionsID=13551

USE RAMS
GO
Update dbo.questions
set questionHyperText ='What is the potential benefit for the community or the society?'
where questionsID=13537

USE RAMS
GO
Update dbo.questions
set questionHyperText ='What is the potential benefit for the subjects?'
where questionsID=13388

USE RAMS
GO
Update dbo.questions
set questionHyperText ='Will you relay the safety data to the subject''s primary healthcare provider and if so how?'
where questionsID=13513

USE RAMS
GO
Update dbo.questions
set questionHyperText ='What is/are the name of device(s), FDA numbers, manufacturer, and supplier?'
where questionsID=13380

USE RAMS
GO
Update dbo.questions
set questionHyperText ='If a subject withdraws from the study, will he or she have the option of getting the remaining portion of the specimen back?'
where questionsID=13613

USE RAMS
GO
update dbo.Questions
set QuestionHyperText = 'Is there a possibility that cell lines will be developed with this specimen?' 
where QuestionsID = 13319;

USE RAMS
GO
update dbo.Questions
set QuestionHyperText = 'Will an entity outside of the VA, such as the VA-Affiliated Nonprofit Research Corporation (VA-NPC), be making the payment?' 
where QuestionsID = 13500;

use RAMS
GO
update dbo.Questions
set QuestionHyperText = 'How will you contact potential subjects? Describe how your subjects will indicate an interest. Is this an opt in or opt out design?' 
where QuestionsID = 13470;

use RAMS
GO
update dbo.Questions
set QuestionHyperText = 'Describe other strategies (e.g. flyers, referral letters. clinic visit(s) to locate subjects):' 
where QuestionsID = 13507;

USE RAMS
GO
update dbo.Questions
set QuestionHyperText = 'Justify the recruitment of children. Include the age of subjects, and whether they will be seen in VA facilities, and the availability of emergency care resources and pediatric expertise at the VA if the children are coming to the VA:' 
where QuestionsID = 13315;

USE RAMS
GO
update dbo.Questions
set QuestionHyperText = 'Is the risk to the fetus caused solely by interventions or procedures that hold out the prospect of direct benefit for the women or the fetus; or, if there is no such prospect of benefit, the risk to the fetus is not greater than minimal and the purpose of the research is for the development of important medical knowledge which cannot be obtained by any other means:' 
where QuestionsID = 13521;

USE RAMS
GO
update dbo.Questions
set QuestionHyperText = 'Discuss what is known from any preclinical studies, including studies on pregnant animals and clinical studies including studies on non-pregnant women, that might provide data for assessing potential risks to pregnant women and fetuses' 
where QuestionsID = 13358;

use RAMS
update dbo.Questions
set QuestionHyperText = 'Describe how you will reveal that the study included deception during the debriefing, which would take place after  the conclusion of study. If you do not plan to do this, justify why.'
where QuestionsID = 13425;

use RAMS
update dbo.Questions
set QuestionHyperText = 'Do you wish to cite an existing protocol or investigator brochure? '
where QuestionsID = 13614;

USE RAMS
GO
update dbo.Questions
set QuestionHyperText = 'What research question and/or hypotheses are you trying to prove?'
where QuestionsID = 13599;

USE RAMS
GO
Update dbo.questions
Set HelpHyperText ='The probability and magnitude of harm or discomfort anticipated in the research are not greater than those ordinarily encountered in daily life or during the performance of routine physical or psychological examinations or tests. E.g. Collection of data from voice, video, digital or image records made for research purposes.'
Where QuestionsID = 13337

USE RAMS
GO
update dbo.Questions
set HelpHyperText = 'To qualify for exempt review, there must not be any significant physical invasion nor intrusion on the privacy of participants and you must be able to identify at least one category from the exempt list.  To qualify for expedited review, you must be able to satisfy certain criteria and identify at least one category from the expedited list.  When you arrive at Section C, there will be additional tooltips to assist you in satisfying the criteria for either exempt or expedited.  If you do not choose either exempt or expedited review, your IRB application automaticaly qualifies for full board review.  Please note that the IRB will make the final determination on whether your application qualifies for exempt, expedited or full board review.  Prior to arriving at Section C, please consult the RAMS Online Help for futher assistance.' 
where QuestionsID = 13495;

USE RAMS
GO
update dbo.Questions
set QuestionHyperText ='If genetic testing is involved, will there be counseling available? If not, enter "Not Applicable".'
where QuestionsID = 13634

use RAMS
update dbo.Questions
set QuestionHyperText = 'Will any part of the study be done offsite?'
where QuestionsID = 13316

use RAMS
update dbo.Questions
set QuestionHyperText = 'If so, which part(s) and where?'
where QuestionsID = 13536

USE RAMS
GO
Update dbo.Questions
set ResponseFormatsID = 3,
QuestionHyperText = 'If there is a need for follow-up examinations or care of participants after the end of their participation in the research, have adequate provisions been made for such examinations or care, considering the length of the individual prisoner sentences? If so, are those provisions described in the protocol?'
where QuestionsID = 13385;


USE RAMS
GO
Update dbo.Questions
set ResponseFormatsID = 3,
QuestionHyperText = 'Are procedures for selection of participants, within the prison, fair to all prisoners and immune from arbitrary intervention by prison authorities?  Are the procedures described in the project?'
where QuestionsID = 13378;

use RAMS
update dbo.Questions
set QuestionHyperText = 'Are you also requesting a waiver of the requirement to maintain a master list of subjects?'
where QuestionsID = 13317;


